/*PSC'99$B%W%m%0%i%`(B
$B:n@.<T!';3M|Bg3X9)3XItEE;R>pJs9)3X2J(BK$B%/%i%9(B3$BG/!&@P86(B $B@?(B
Copyright $B#N#E#C(B $B#C!u#C%a%G%#%"8&5f=j(B $BJBNs=hM}%;%s%?!<(B*/
#include <stdio.h>
#include <math.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>

#include "mpi.h"

#define LOG(a,b) (log(b)/log(a))

typedef struct 
{
int n;
int m;
int tags1;
int tagr1;  
int tags2;
int tagr2;
int stype1;
int stype2;
}scedule;

int np;/*PEnumber*/
int npes;/*PE$B?t(B*/
double *vec4list;/*$B2rEzMQ%j%9%H(B*/

int psc99(int *numelen)
{
  int npc;
  char **npv;
  MPI_Status status;
  int *ln;
  double *norm;
  int *nlist;
  int n;
  int m;
  int lsize;/*1PE$B$K3JG<$5$l$k%j%9%H?t(B*/  
  int mlsize;
  int flag1;
  int flag2;
  scedule *step;
/*----------------------------$BJBNs=hM}3+;O!*!*(B-------------------------------*/
  MPI_Init(&npc,&npv);/*$BJBNs=hM}3+;O(B*/
  MPI_Comm_size(MPI_COMM_WORLD,&npes);/*$BAm(BPE$B?t<hF@(B*/
  MPI_Comm_rank(MPI_COMM_WORLD,&np);/*PE$BHV9f<hF@(B*/
/*-------------------------$B%j%9%H<hF@$KEv$C$F$N@_Dj(B--------------------------*/
  setnumpeatgetlist(npes);/*PE$B?t@_Dj(B*/
  getnumpeatgetlist();/*$B<hF@(B*/
  
  step=malloc((LOG(2,npes)+1)*sizeof(scedule));/*$B$3$N%=!<%F%#%s%0$NMW$H$J$k%9%F%C%W3NJ](B*/
  setstep(step);/*$B%9%F%C%W;;=P(B*/

/*------------------------------$B%j%9%H<hF@(B-----------------------------------*/
  lsize=getlist(vec4list,0);/*1PE$BEv$j$N%j%9%H%5%$%:<hF@(B*/

  MPI_Allreduce(&lsize,&mlsize,1,MPI_INT,MPI_MAX,MPI_COMM_WORLD);/*$B%j%9%H$N6QEyIT6QEy%A%'%C%/(B*/

  if(mlsize==lsize)
    flag2=0;
  else
    flag2=1;

  MPI_Allreduce(&flag2,&flag1,1,MPI_INT,MPI_MAX,MPI_COMM_WORLD);/*$B%j%9%H%A%'%C%/(B*/

  if(flag1!=0)/*$B%j%9%HIT6QEy$J$H$-$N%k!<%A%s(B*/
    {
      *numelen=mlsize;/*$B%j%9%H$r:GBg?t$X9g$o$;$k(B*/
      norm=malloc(mlsize*sizeof(double));/*$B%N%k%`$N<hF@(B*/
      nlist=malloc(mlsize*sizeof(int));/*$B%N%k%`$NE:;z3JG<MQ(B*/
      vec4list=malloc(mlsize*4*sizeof(double));/*$B2rEzDs=PMQ(B*/
      getlist(vec4list,lsize);/*$B%j%9%H<hF@(B*/

      for (n=0;n<lsize;n++)/*$B%N%k%`7W;;(B*/
	{
	  *(nlist+n)=n;
	  *(norm+n)=(*(vec4list+n*4))*(*(vec4list+n*4))+(*(vec4list+n*4+1))*(*(vec4list+n*4+1))+(*(vec4list+n*4+2))*(*(vec4list+n*4+2))+(*(vec4list+n*4+3))*(*(vec4list+n*4+3));
	}
      if(mlsize!=lsize)
	for(n=lsize;n<mlsize;n++)
	  {
	    *(nlist+n)=n;
	    *(vec4list+n*4)=0.01;
	    *(vec4list+n*4+1)=0.01+0.001;
	    *(vec4list+n*4+2)=0.01+0.002;
	    *(vec4list+n*4+3)=0.01+0.003;
	    *(norm+n)=-0.001;
	  }  
      
      if (np%2<1)
	n=1;
      else
	n=2;

      quicksort(vec4list,norm,mlsize,nlist,0,mlsize-1,n);/*$B%/%$%C%/%=!<%H3+;O(B*/
      insertionsort(vec4list,norm,nlist,mlsize,n);/*$BA^F~J}3+;O(B*/
      lcp(vec4list,norm,nlist,mlsize);/*$B%j%9%H$N%3%T!<(B*/
      bitonic(vec4list,norm,step,mlsize,m);/*$B%P%$%H%K%C%/%=!<%H3+;O(B*/

      setansweraddress(vec4list);/*$B2rEz%"%I%l%9@_DjMQ(B*/
      n=0;
      while(n<mlsize&&*(norm+n)<0)/*$BIT6QEyJd@5(B*/
	{
	  n++;
	  setansweraddress(vec4list+4*n);
	  --*(numelen);
	}
    }
  else
    {
      *numelen=lsize;/*$B%j%9%H?t<hF@(B*/
      norm=malloc(lsize*sizeof(double));/*$B%a%b%j3d$jEv$F(B*/
      nlist=malloc(lsize*sizeof(int));/*$B%N%k%`$NE:;z3JG<MQ(B*/
      vec4list=malloc(lsize*4*sizeof(double)); /*$B%a%b%j3d$jEv$F(B*/
      
      getlist(vec4list,lsize);/*$B%j%9%H<hF@(B*/
      for (n=0;n<lsize;n++)/*$B%N%k%`7W;;(B*/
	{
	  *(nlist+n)=n;
	  *(norm+n)=(*(vec4list+n*4))*(*(vec4list+n*4))+(*(vec4list+n*4+1))*(*(vec4list+n*4+1))+(*(vec4list+n*4+2))*(*(vec4list+n*4+2))+(*(vec4list+n*4+3))*(*(vec4list+n*4+3));
	}
      
      if (np%2<1)
	n=1;
      else
	n=2;
      
      quicksort(vec4list,norm,lsize,nlist,0,lsize-1,n);/*$B%/%$%C%/%=!<%H3+;O(B*/
      insertionsort(vec4list,norm,nlist,lsize,n);/*$BA^F~J}3+;O(B*/
      lcp(vec4list,norm,nlist,lsize);/*$B%j%9%H$N%3%T!<(B*/
      bitonic(vec4list,norm,step,lsize,m);/*$B%P%$%H%K%C%/%=!<%H3+;O(B*/
      setansweraddress(vec4list);     /*$B2rEz%"%I%l%9@_DjMQ(B*/
    }
  return npes; /*$B=*N;(B*/
}


int lcp(double *vec4list,double *norm,int *nlist,int lsize)
{
double *vec4list2;
double *norm2;
int n;

norm2=malloc(lsize*sizeof(double));
if(norm2==NULL)
  printf("norm2-error\n");

for(n=0;n<lsize;n++)
  {
    *(norm2+n)=*(norm+(*(nlist+n)));
  }
for(n=0;n<lsize;n++)
  {
    *(norm+n)=*(norm2+n);
  }
free(norm2);

vec4list2=malloc(lsize*sizeof(double)*4);
if(vec4list2==NULL)
  printf("vec4list2-error\n");

for(n=0;n<lsize;n++)
  {
    *(vec4list2+n*4)=*(vec4list+(*(nlist+n))*4);
    *(vec4list2+n*4+1)=*(vec4list+(*(nlist+n))*4+1);
    *(vec4list2+n*4+2)=*(vec4list+(*(nlist+n))*4+2);
    *(vec4list2+n*4+3)=*(vec4list+(*(nlist+n))*4+3);
  }
for(n=0;n<lsize;n++)
  {
    *(vec4list+n*4)=*(vec4list2+n*4);
    *(vec4list+n*4+1)=*(vec4list2+n*4+1);
    *(vec4list+n*4+2)=*(vec4list2+n*4+2);
    *(vec4list+n*4+3)=*(vec4list2+n*4+3);
  }
free(vec4list2);
}

int mypeid()
{
  return np;
} 

int quicksort(double *vec4list,double *norm,int lsize,int *nlist,int p,int q,int n)
{
  int i,j;
  int PV;
  if (p+15<q)
    {
      PV=getpivot(vec4list,norm,nlist,p,q);
      part(vec4list,norm,nlist,lsize,p,q,&j,&i,PV,n);
      quicksort(vec4list,norm,lsize,nlist,p,j,n); 
      quicksort(vec4list,norm,lsize,nlist,i,q,n);
    }
}

int part(double *vec4list,double *norm,int *nlist,int lsize,int p,int q,int *j ,int *i,int PV,int n)
{
  double s;
  double e0;
  double e1;
  double e2;
  double e3;
  int a;
  (*i)=p;
  (*j)=q;  
  while ((*i)<=(*j))
    {
      if(n==1)
	{
	  while(jyoken1(vec4list,norm,*(nlist+(*i)),PV))
	    ++(*i);
	  while(jyoken2(vec4list,norm,*(nlist+(*j)),PV))	 
     	    --(*j);
	}
      else
	{ 
	  while(jyoken2(vec4list,norm,*(nlist+(*i)),PV))
	    ++(*i);
	  while(jyoken1(vec4list,norm,*(nlist+(*j)),PV))	
	    --(*j);
	}
      if ((*i)<=(*j)) 
	{
	  swap(nlist,*i,*j);
	  ++(*i);
	  --(*j);
	}    
    } 
}
int insertionsort(double *vec4list,double *norm,int *nlist,int lsize,int n)
{
  int i;
  int j;
  int k;
  if(n==1)
    {
      for(i=1;i<lsize;i++)
	{
	  k=*(nlist+i);
	  j=i;
	  while(j>0&&jyoken2(vec4list,norm,*(nlist+j-1),k))
	    {
	      *(nlist+j)=*(nlist+j-1);
	      j=j-1;
	    }
	  *(nlist+j)=k;
	}
    }
  else
    {
      for(i=1;i<lsize;i++)
	{
	  k=*(nlist+i);
	  j=i;
	  while(j>0&&jyoken1(vec4list,norm,*(nlist+j-1),k))
	    {
	      *(nlist+j)=*(nlist+j-1);
	      j=j-1;
	    }
	  *(nlist+j)=k;
	}
    }  
}

int jyoken1(double *vec4list,double *norm,int p,int q)
{ 
   if(*(norm+p)<*(norm+q))
     return 1;
   if(*(norm+p)>*(norm+q))
     return 0;
   if(*(vec4list+p*4)<*(vec4list+q*4))
     return 1;
   if(*(vec4list+p*4)>*(vec4list+q*4))
     return 0;
   if(*(vec4list+p*4+1)<*(vec4list+q*4+1))
     return 1;
   if(*(vec4list+p*4+1)>*(vec4list+q*4+1))
     return 0;
   if(*(vec4list+p*4+2)<*(vec4list+q*4+2))
     return 1;
   if(*(vec4list+p*4+2)>*(vec4list+q*4+2))
     return 0;
   if(*(vec4list+p*4+3)<*(vec4list+q*4+3))
     return 1;
   return 0;
}

int jyoken2(double *vec4list,double *norm,int p,int q)
{ 
   if(*(norm+p)>*(norm+q))
     return 1;
   if(*(norm+p)<*(norm+q))
     return 0;
   if(*(vec4list+p*4)>*(vec4list+q*4))
     return 1;
   if(*(vec4list+p*4)<*(vec4list+q*4))
     return 0;
   if(*(vec4list+p*4+1)>*(vec4list+q*4+1))
     return 1;
   if(*(vec4list+p*4+1)<*(vec4list+q*4+1))
     return 0;
   if(*(vec4list+p*4+2)>*(vec4list+q*4+2))
     return 1;
   if(*(vec4list+p*4+2)<*(vec4list+q*4+2))
     return 0;
   if(*(vec4list+p*4+3)>*(vec4list+q*4+3))
     return 1;
   return 0;
}

int swap(int *nlist,int i,int j)
{
 int c;
 c=*(nlist+i);
 *(nlist+i)=*(nlist+j);
 *(nlist+j)=c;
}

int getpivot(double *vec4list,double *norm,int *nlist,int p,int q)
{
  int n;
  n=(p+q)/2;
  
  if(jyoken2(vec4list,norm,*(nlist+p),*(nlist+n)))
    swap(nlist,p,n);
  if(jyoken2(vec4list,norm,*(nlist+p),*(nlist+q)))
    swap(nlist,p,q);
  if(jyoken2(vec4list,norm,*(nlist+n),*(nlist+q)))
    swap(nlist,n,q);

  return *(nlist+n);
}

int bitonic(double *vec4list,double *norm,scedule *step,int lsize)
{
  int i,j;
  int k,l,m,n;
  int *nlist;
  for (i=1;i<=LOG(2,npes);i++)
    {
      msort(vec4list,norm,(step+i)->n,(step+i)->m,(step+i)->tags1,(step+i)->tagr1,(step+i)->tags2,(step+i)->tagr2,(step+i)->stype1,(step+i)->stype2,lsize,i);
      if(i!=1)
	{
	  for(j=i;j>1;j--)
	    {
	      nlist=malloc(lsize*sizeof(int));

	      if(nlist==NULL)
		printf("nlist-msort-error\n");

	      for (k=0;k<lsize;k++)
		*(nlist+k)=k;

	      if((step+i)->stype1==1)
		if((step+j-1)->n>(step+j-1)->m)
		  m=2;
		else
		  m=1;
	      else
		if((step+j-1)->n>(step+j-1)->m)
		  m=1;
		else
		  m=2;

	      if((step+j-1)->n>(step+j-1)->m)
		n=2;
	      else
		n=1;

	      msort2(vec4list,norm,lsize,nlist,n);
	      lcp(vec4list,norm,nlist,lsize);

	      msort(vec4list,norm,(step+j-1)->n,(step+j-1)->m,(step+j-1)->tags1,(step+j-1)->tagr1,(step+j-1)->tags2,(step+j-1)->tagr2,(step+i)->stype1,m,lsize,i);	      
	      free(nlist);
	    }
	}

      nlist=malloc(lsize*sizeof(int));
      if(nlist==NULL)
	printf("nlist-error\n"); 
      for(j=0;j<lsize;j++)
	*(nlist+j)=j;
      msort2(vec4list,norm,lsize,nlist,(step+i)->stype1);
      lcp(vec4list,norm,nlist,lsize);
      free(nlist);
    } 
}


int msort(double *vec4list,double *norm,int n,int m,int tags1,int tagr1,int tags2,int tagr2,int stype1,int stype2,int lsize,int i)
{
  int c;
  int j;
  MPI_Status status; 
  double *norm2;
  double *vec4list2;
  
  norm2=malloc(lsize*sizeof(double));
  vec4list2=malloc(4*lsize*sizeof(double));
  
  if(norm2==NULL)
    printf("rnorm-error\n");  
  if(vec4list2==NULL)
    printf("rnum-error\n");
  
  if(n<m)
    {
      MPI_Send(norm,lsize,MPI_DOUBLE,m,tags1,MPI_COMM_WORLD);
      MPI_Recv(norm2,lsize,MPI_DOUBLE,m,tagr1,MPI_COMM_WORLD,&status);
      MPI_Send(vec4list,lsize*4,MPI_DOUBLE,m,tags2,MPI_COMM_WORLD);
      MPI_Recv(vec4list2,lsize*4,MPI_DOUBLE,m,tagr2,MPI_COMM_WORLD,&status);
    }
  else
    {   
      MPI_Recv(norm2,lsize,MPI_DOUBLE,m,tagr1,MPI_COMM_WORLD,&status);
      MPI_Send(norm,lsize,MPI_DOUBLE,m,tags1,MPI_COMM_WORLD);
      MPI_Recv(vec4list2,lsize*4,MPI_DOUBLE,m,tagr2,MPI_COMM_WORLD,&status);
      MPI_Send(vec4list,lsize*4,MPI_DOUBLE,m,tags2,MPI_COMM_WORLD);
      }
  merge(vec4list,vec4list2,norm,norm2,lsize,stype1,stype2);
  free(norm2);
  free(vec4list2);
}

int merge(double *vec4list,double *vec4list2,double *norm,double *norm2,int lsize,int stype1,int stype2)
{
  int n;
  if(stype2==1)
    if(stype1==1)
      for(n=lsize-1;n>=0&&jyoken4(vec4list,vec4list2,norm,norm2,n);n--)
	swap2(vec4list,vec4list2,norm,norm2,n);
    else   
      for(n=0;n<lsize&&jyoken4(vec4list,vec4list2,norm,norm2,n);n++)
	swap2(vec4list,vec4list2,norm,norm2,n);
  else
    if(stype1==1)
      for(n=lsize-1;n>=0&&jyoken3(vec4list,vec4list2,norm,norm2,n);n--)
	swap2(vec4list,vec4list2,norm,norm2,n);
    else
      for(n=0;n<lsize&&jyoken3(vec4list,vec4list2,norm,norm2,n);n++)
	swap2(vec4list,vec4list2,norm,norm2,n);
}
int msort2(double *vec4list,double *norm,int lsize,int *nlist,int stype1)
{
  int p;
  int q;
  int r;
  int n;
  int maxnum;
  int minnum;
  maxnum=max(vec4list,norm,lsize);
  minnum=min(vec4list,norm,lsize);
  if(stype1==1)
    {
      if((maxnum!=0&&(maxnum!=lsize-1)))
	{
	  q=maxnum;
	  r=lsize-1;
	  p=0;
	  for(n=0;n<lsize;n++)
	    {
	      if(r==q||(p<=q&&jyoken5(vec4list,norm,p,r)))
		*(nlist+n)=p++;
	      else
		*(nlist+n)=r--;
	    }
	}
      else
	if((minnum!=0&&(minnum!=lsize-1)))
	  {
	    q=minnum;
	    r=lsize-1;
	    p=0;	  
	    for(n=lsize-1;n>=0;n--)
	      {
		if(r==q||(p<=q&&jyoken6(vec4list,norm,p,r)))
		  *(nlist+n)=p++;
		else
		  *(nlist+n)=r--;
	      }  
	  }
      else
	if((minnum==lsize-1)&&(maxnum==0))
	  {
	    for(n=0;n<lsize;n++)
	      *(nlist+n)=lsize-1-n;
	  }
    }
  else
    {       
      if((minnum!=0&&(minnum!=lsize-1)))
	{	
	  q=minnum;
	  r=lsize-1;
	  p=0;	  
	  for(n=0;n<lsize;n++)
	    {
	      if(r==q||(p<=q&&jyoken6(vec4list,norm,p,r)))
		*(nlist+n)=p++;
	      else
		*(nlist+n)=r--;
	    }  
	}
      else
	if((maxnum!=0&&(maxnum!=lsize-1)))
	  {
	    q=maxnum;
	    r=lsize-1;
	    p=0;
	    for(n=lsize-1;n>=0;n--)
	      {
		if(r==q||(p<=q&&jyoken5(vec4list,norm,p,r)))
		  *(nlist+n)=p++;
		else
		  *(nlist+n)=r--;
	      }
	  }
	else
	  if(maxnum==lsize-1&&minnum==0)
	    {
	      for(n=0;n<lsize;n++)
		*(nlist+n)=lsize-1-n;
	    }
    }
}
int jyokenequal(double *vec4list,double *norm,int q,int p)
{
if(*(norm+q)==*(norm+p)&&*(vec4list+q*4)==*(vec4list+p*4)&&*(vec4list+q*4+1)==*(vec4list+p*4+1)&&*(vec4list+q*4+2)==*(vec4list+p*4+2)&&*(vec4list+q*4+3)==*(vec4list+p*4+3))
  return 1;
else
  return 0;
}
int max(double *vec4list,double *norm,int lsize)
{
  int n;
  int a;
  a=0;
  for(n=0;n<lsize;n++)
    if(jyoken5(vec4list,norm,a,n))
      a=n;
  if(jyokenequal(vec4list,norm,a,0))
    a=0;
 return a;
}
int min(double *vec4list,double *norm,int lsize)
{
  int n;
  int a;
  a=0;
  for(n=0;n<lsize;n++)
    if(jyoken6(vec4list,norm,a,n))
      a=n;
  if(jyokenequal(vec4list,norm,a,0))
    a=0;
  return a;
}
int jyoken5(double *vec4list,double *norm,int p,int q)
{ 
   if(*(norm+p)<*(norm+q))
     return 1;
   if(*(norm+p)>*(norm+q))
     return 0;
   if(*(vec4list+p*4)<*(vec4list+q*4))
     return 1;
   if(*(vec4list+p*4)>*(vec4list+q*4))
     return 0;
   if(*(vec4list+p*4+1)<*(vec4list+q*4+1))
     return 1;
   if(*(vec4list+p*4+1)>*(vec4list+q*4+1))
     return 0;
   if(*(vec4list+p*4+2)<*(vec4list+q*4+2))
     return 1;
   if(*(vec4list+p*4+2)>*(vec4list+q*4+2))
     return 0;
   if(*(vec4list+p*4+3)<*(vec4list+q*4+3))
     return 1;
   if(*(vec4list+p*4+3)>*(vec4list+q*4+3))
     return 0;
   return 1;
}

int jyoken6(double *vec4list,double *norm,int p,int q)
{ 
   if(*(norm+p)>*(norm+q))
     return 1;
   if(*(norm+p)<*(norm+q))
     return 0;
   if(*(vec4list+p*4)>*(vec4list+q*4))
     return 1;
   if(*(vec4list+p*4)<*(vec4list+q*4))
     return 0;
   if(*(vec4list+p*4+1)>*(vec4list+q*4+1))
     return 1;
   if(*(vec4list+p*4+1)<*(vec4list+q*4+1))
     return 0;
   if(*(vec4list+p*4+2)>*(vec4list+q*4+2))
     return 1;
   if(*(vec4list+p*4+2)<*(vec4list+q*4+2))
     return 0;
   if(*(vec4list+p*4+3)>*(vec4list+q*4+3))
     return 1;
   if(*(vec4list+p*4+3)<*(vec4list+q*4+3))
     return 0;
   return 1;
}

int jyoken3(double *vec4list,double *vec4list2,double *norm,double *norm2,int n)
{ 
  if(*(norm+n)<*(norm2+n))
    return 1;
  if(*(norm+n)>*(norm2+n))
     return 0;   
   if(*(vec4list+n*4)<*(vec4list2+n*4))
     return 1;
   if(*(vec4list+n*4)>*(vec4list2+n*4))
     return 0;
   if(*(vec4list+n*4+1)<*(vec4list2+n*4+1))
     return 1;
   if(*(vec4list+n*4+1)>*(vec4list2+n*4+1))
     return 0;
   if(*(vec4list+n*4+2)<*(vec4list2+n*4+2))
     return 1;
   if(*(vec4list+n*4+2)>*(vec4list2+n*4+2))
     return 0;
   if(*(vec4list+n*4+3)<*(vec4list2+n*4+3))
     return 1;
  return 0;
 }    

int jyoken4(double *vec4list,double *vec4list2,double *norm,double *norm2,int n)
{ 
   if(*(norm+n)>*(norm2+n))
     return 1;
   if(*(norm+n)<*(norm2+n))
     return 0;   
   if(*(vec4list+n*4)>*(vec4list2+n*4))
     return 1;
   if(*(vec4list+n*4)<*(vec4list2+n*4))
     return 0;
   if(*(vec4list+n*4+1)>*(vec4list2+n*4+1))
     return 1;
   if(*(vec4list+n*4+1)<*(vec4list2+n*4+1))
     return 0;
   if(*(vec4list+n*4+2)>*(vec4list2+n*4+2))
     return 1;
   if(*(vec4list+n*4+2)<*(vec4list2+n*4+2))
     return 0;
   if(*(vec4list+n*4+3)>*(vec4list2+n*4+3))
     return 1;
   return 0;
 }    
int swap2(double *vec4list,double *vec4list2,double *norm,double *norm2,int n)
{
  *(norm+n)=*(norm2+n);
  *(vec4list+n*4)=*(vec4list2+n*4);
  *(vec4list+n*4+1)=*(vec4list2+n*4+1);
  *(vec4list+n*4+2)=*(vec4list2+n*4+2);
  *(vec4list+n*4+3)=*(vec4list2+n*4+3);
}

int setstep(scedule *step)
{
  int n,m;
  int i;
  int j;
  i=2;
  j=1;
  for(n=1;n<=LOG(2,npes);n++)
      {
      if(np%i<j)
	{
	  i=i*2;
	  j=j*2;
	  (step+n)->n=np;
	  (step+n)->m=np+(j/2);
	  (step+n)->tags1=np*100+(np+(j/2))*10+1;
	  (step+n)->tagr1=np*100+(np+(j/2))*10+2;
	  (step+n)->tags2=np*100+(np+(j/2))*10+3;
	  (step+n)->tagr2=np*100+(np+(j/2))*10+4;
	  if (np%i<j)
	    { 
	      (step+n)->stype1=1;	
	      (step+n)->stype2=1;	
	    }
	  else
	    {
	      (step+n)->stype1=2;
	      (step+n)->stype2=2;		   	      
	    }
	}
      else
	{
	  i=i*2;
	  j=j*2;
	  (step+n)->n=np;
	  (step+n)->m=np-(j/2);
	  (step+n)->tags1=(np-(j/2))*100+np*10+2;
	  (step+n)->tagr1=(np-(j/2))*100+np*10+1;
	  (step+n)->tags2=(np-(j/2))*100+np*10+4;
	  (step+n)->tagr2=(np-(j/2))*100+np*10+3;          	      
	  if (np%i<j)
	    {
	      (step+n)->stype1=1;	
	      (step+n)->stype2=2;	  	      	      
	    }
	  else
	    {
	      (step+n)->stype1=2;	   
	      (step+n)->stype2=1;	   	      	      
	    }
	}	  
    }
}

